local roundLoop = true;
local roundTimer = 0;
local deathTimer = 0
local gameLoop = false;
local startUp = false;
local deathLoop = false;

--Game Loop
while pge.running() do
	pge.controls.update();
	pge.gfx.startdrawing();
	pge.gfx.clearscreen();
	
	if not deathLoop then
		--Update Cursor
		updateCursor();
		--Update Player logic
		updatePlayer();
		--Function name speaks for it self
		drawEverything();
	
		font:activate();
		if player.currentGun.empty or player.unarmed then
			font:print(0, 0, white, "Current Ammo: 0".."|".."0");
		elseif not player.reloading and not player.currentGun.empty then
			font:print(0, 0, white, "Current Ammo: "..((player.currentGun.currentClip + 1) - player.currentBullet).."|"..player.currentGun.currentAmmo);
		elseif player.reloading and not player.currentGun.empty then
			font:print(0, 0, white, "Current Ammo: "..((player.currentGun.currentClip + 1) - player.currentBullet).."|"..player.currentGun.currentAmmo 
				- player.currentGun.currentClip);
		end
	
		if player.unarmed then
			font:print(105, 0, white, "Current Gun: Unarmed");
		elseif not player.unarmed then
			font:print(105, 0, white, "Current Gun: "..player.currentGun.name);
		end
		
		font:print(281, 0, white, "Score ");
		font:print(281, 8, white, ""..tostring(player.score));
		font:print(351, 0, white, "Running");
		font:print(431, 0, white, "Armor "..tostring(player.armor));
		font:print(430, 8, white, "Health "..tostring(player.health));
		
		--Running bar
		if player.runTime >= 0 then
			pge.gfx.drawrect(351, 8, player.runTime, 8, red)
		end
		
		if Debug then	
			font:print(0, 60, white, "Appear: "..tostring(machineGun.appear));
		end
		
		--Are we reloading? Show Player we are reloading visually.
		if player.reloading then
			bloodFont:activate();
			bloodFont:print(390, 258, red, "RELOADING");
		end
		
		if roundLoop then
			--Increment counter
			roundTimer = roundTimer + 1;
	
			if roundTimer >= 100 then
				roundTimer = 0;
				roundLoop = false;
				gameLoop = true;
			end
			
			--Start up re-initialize zombies and gifts
			if not startUp then
				math.randomseed(os.time());
			
				for i = 1, round.number * round.zombies do
					--Left side of player
					if zombie[i].posX ==  1 then
						zombie[i].x = math.random(player.worldX - 445, player.worldX -380);
					elseif zombie[i].posX == 2 then   --Right side of player
						zombie[i].x = math.random(player.worldX + 380, player.worldX + 445);
					end
			
					--Above player
					if zombie[i].posY == 1 then
						zombie[i].y = math.random(player.worldY - 285, player.worldY - 222);
					elseif zombie[i].posY == 2 then  --Below player
						zombie[i].y = math.random(player.worldY + 222, player.worldY + 285);
					end
					
					zombie[i].img = zombieWalking;
					zombie[i].currentSprite = zombieWalkingAnim.startFrame;
					zombie[i].walking = true;
					zombie[i].active = true;
				end
			
				--If low on ammo, add in a nice gift for the player 
				if player.currentGun.currentAmmo <= 20 then
					ammo[1] = {x = math.random(20, 460), y = math.random(20, 252), img = ammoCrate, used = false};
				elseif player.currentGun.currentAmmo <= 10 then
					ammo[1] = {x = math.random(20, 460), y = math.random(20, 252), img = ammoCrate, used = false};
					ammo[2] = {x = math.random(20, 460), y = math.random(20, 252), img = ammoCrate, used = false};
				end
			end
			
			--Set created ammo to true
			startUp = true;
			
			bloodFont:activate();
			bloodFont:print(0, 258, red, "Round "..round.number.." Start!");
		end
			
		if gameLoop then 
			--Update Zombies And render
			zombies();
		
			if player.death and player.currentSprite == 8 then
				deathTimer = deathTimer + 1;
			
				if deathTimer > 200 then
					gameLoop = false;
					roundLoop = false;
					deathTimer = 0;
					deathLoop = true;
					player.death = false;
				end
			end
			
			if zombiesKilled == (round.number * round.zombies) then
				gameLoop = false;
				startUp = false;
				round.number = round.number + 1;
				zombiesKilled = 0;
				roundLoop = true;
			end
		end
	elseif deathLoop then
		bloodFont:activate();
		bloodFont:print(150, 104, red, "Your Dead MWAAHHHHH!!");
		bloodFont:print(150, 118, red, "Your Score was...");
		bloodFont:print(152, 134, red, ""..player.score);
		bloodFont:print(150, 164, red, "Press X to restart or Circle to Quit.");
		
		if pge.controls.pressed(PGE_CTRL_CROSS) then
			round.number = 1;
			player.score = 0;
			player.width = 48;
			player.worldX = 100;
			player.worldY = 100;
			player.health = 100;
			player.armor = 100;
			roundLoop = true;
		end
			
		if pge.controls.pressed(PGE_CTRL_CIRCLE) then
			pge.exit();
		end
	end
	
	--End drawing & swap the buffers
	pge.gfx.enddrawing();
	pge.gfx.swapbuffers();
end
